<script setup lang="ts">
import { ref, defineAsyncComponent, onMounted } from "vue";
import http from "@/plugins/http";
import config from "@/app.config";
import { useQuasar } from "quasar";
import { useRoute, useRouter } from "vue-router";
import { useCounterMixin } from "@/stores/mixin";
import { useAssignDataStore } from "@/modules/05_placement/storeAssign";
const assignStore = useAssignDataStore();
const { fecthdataAssign } = assignStore;

const Header = defineAsyncComponent(
  () =>
    import(
      "@/modules/05_placement/components/probation/FormEvaluation/Header.vue"
    )
);
const FormEvaluateScore = defineAsyncComponent(
  () =>
    import(
      "@/modules/05_placement/components/probation/FormEvaluation/FormEvaluateScore.vue"
    )
);

const router = useRouter();
const route = useRoute();
const mixin = useCounterMixin();
const $q = useQuasar();
const { showLoader, hideLoader, messageError, success } = mixin;
const assignId = ref<string>(route.params.form.toString());
const personalId = ref<string>(route.params.personalId.toString());

const fullname = ref<string>("");
const tab = ref<string>("save1");
const tabs = ref<any>([]);
const dataArrayNumber = ref<number>(1);
const evaluate = ref<any>([]);

onMounted(() => {
  fecthAssign(assignId.value);
});

const fecthAssign = async (id: string) => {
  showLoader();
  await http
    .get(config.API.createformChairman(id))
    .then(async (res: any) => {
      await fecthdataAssign(res.data.data);
      evaluate.value = assignStore.evaluate;
      fullname.value = res.data.data.experimentee ? res.data.data.experimentee.name : "";
      tabs.value = evaluate.value;
      dataArrayNumber.value = 1;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
};
const downloadFile = (response: any, filename: string) => {
  const link = document.createElement("a");
  var fileName = filename;
  link.href = window.URL.createObjectURL(new Blob([response.data]));
  link.setAttribute("download", fileName);
  document.body.appendChild(link);
  link.click();
  document.body.removeChild(link);
};

const FileDownload = async (type: string) => {
  let numTab = evaluate.value.find((e: any) => e.no === dataArrayNumber.value);
  showLoader();
  await http
    .get(config.API.reportEvaluateChairman(type, numTab.id,numTab.no), {
      responseType: "blob",
    })
    .then(async (res) => {
      downloadFile(
        res,
        `แบบประเมินผล(คณะกรรมการ)_${fullname.value}_ครั้งที่${numTab.no}.${type}`
      );
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
};
const addData = () => {
  router.push(
    `/probation/detail/addevaluascore/${personalId.value}/${assignId.value}`
  );
};

const changeTab = (tabVal: string) => {
  tab.value = tabVal;
  dataArrayNumber.value = Number(tabVal.charAt(4));
};
</script>

<template>
  <Header
    v-if="tabs.length > 0"
    :change-tab="changeTab"
    :loop="tabs.length"
    :add-data="addData"
    :FileDownload="FileDownload"
  />

  <q-tab-panels
    v-model="tab"
    animated
    swipeable
    vertical
    transition-prev="jump-up"
    transition-next="jump-up"
    v-if="tabs.length > 0"
    class="mt"
    ><q-tab-panel
      v-for="item in assignStore.evaluate"
      :name="`save${item.no}`"
      :key="item.no"
    >
      <FormEvaluateScore
        :tab="tab"
        :data="evaluate.find((x: any) => x.no === dataArrayNumber)"
        action="edit"
      />
    </q-tab-panel>
  </q-tab-panels>
  <!-- <q-page-container v-if="tabs.length > 0">
    <FormEvaluateScore
      :tab="tab"
      :data="evaluate.find((x: any) => x.no === dataArrayNumber)"
      action="edit"
    />
  </q-page-container> -->

  <div class="q-gutter-md" v-if="tabs.length === 0">
    <div class="flex justify-center items-center q-my-md q-gutter-md">
      <q-btn outline color="primary" label="สร้างแบบประเมิน" @click="addData" />
    </div>
  </div>
</template>

<style lang="scss" scoped>
.mt {
  margin-top: 25px;
}
</style>
